### Method

# EBackend WebDAVCollectionBackend discover_sync

since: 3.26

#### Declaration [src]

    ESourceAuthenticationResult
    e_webdav_collection_backend_discover_sync (
      EWebDAVCollectionBackend* webdav_backend,
      const gchar* calendar_url,
      const gchar* contacts_url,
      const ENamedParameters* credentials,
      gchar** out_certificate_pem,
      GTlsCertificateFlags* out_certificate_errors,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

This function is usually called in EBackend::authenticate_sync() implementation of the descendant, causing discovery of CalDAV and CardDAV sources on given URLs. If either of `calendar_url` and `contacts_url` is `NULL`, that that part is skipped. The `calendar_url` covers all calendars, memo lists and task lists.

The function also takes care of `e_collection_backend_authenticate_children()` on success.

Available since: 3.26

#### Parameters

`calendar_url`

  Type: `const gchar*`

  A URL to search calendars at, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`contacts_url`

  Type: `const gchar*`

  A URL to search contacts at, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`credentials`

  Type: `ENamedParameters`

  Credentials to use when running the discovery.

  The data is owned by the caller of the method.

`out_certificate_pem`

  Type: `gchar**`

  Optional return location for a server SSL certificate in PEM format, when the operation failed with an SSL error.

  The argument will be set by the function.
  The argument can be set to `NULL` by the method.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.
  The value is a NUL terminated UTF-8 string.

`out_certificate_errors`

  Type: `GTlsCertificateFlags`

  Optional `GTlsCertificateFlags`, with certificate error flags when the operation failed with SSL error.

  The argument will be set by the function.
  The argument can be set to `NULL` by the method.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `ESourceAuthenticationResult`

An `ESourceAuthenticationResult` describing whether discovery on given addresses succeeded.